function hout=suptitle(str)
%SUPTITLE Puts a title above all subplots.
%	SUPTITLE('text') adds text to the top of the figure
%	above all subplots (a "super title"). Use this function
%	after all subplot commands.

% Drea Thomas 6/15/95 drea@mathworks.com

% Warning: If the figure or axis units are non-default, this
% will break.

% Parameters used to position the supertitle.


% Amount of the figure window devoted to subplots
plotregion = .92;

% Y position of title in normalized coordinates
titleypos  = .95;

% Fontsize for supertitle
fs = get(gcf,'defaultaxesfontsize')+2;

% Fudge factor to adjust y spacing between subplots
fudge=1;

haold = gca;
figunits = get(gcf,'units');

% Get the (approximate) difference between full height (plot + title
% + xlabel) and bounding rectangle.

	if (~strcmp(figunits,'pixels')),
		set(gcf,'units','pixels');
		post = get(gcf,'position');
		set(gcf,'units',figunits);
	else,
		post = get(gcf,'position');
	end
	ff = (fs-4)*1.27*5/post(4)*fudge;

        % The 5 here reflects about 3 characters of height below
        % an axis and 2 above. 1.27 is pixels per point.

% Determine the bounding rectange for all the plots

% herd = findobj('Type','axes');   



ch = get(gcf,'children');
herd=[];
for i=1:length(ch),
  if strcmp(get(ch(i),'type'),'axes'),
    herd=[herd,ch(i)];
  end
end

	


max_y=0;
min_y=1;

oldtitle =0;
for i=1:length(herd),
	if (~strcmp(get(herd(i),'Tag'),'suptitle')),
		post=get(herd(i),'pos');
		if (post(2) < min_y), min_y=post(2)-ff/5*3;end;
		if (post(4)+post(2) > max_y), max_y=post(4)+post(2)+ff/5*2;end;
	else,
		oldtitle = herd(i);
	end
end

if max_y > plotregion,
	scale = (plotregion-min_y)/(max_y-min_y);
	for i=1:length(herd),
		post = get(herd(i),'position');
		post(2) = (post(2)-min_y)*scale+min_y;
		post(4) = post(4)*scale-(1-scale)*ff/5*3;
		set(herd(i),'position',post);
	end
end

np = get(gcf,'nextplot');
set(gcf,'nextplot','add');
if (oldtitle),
	delete(oldtitle);
end
ha=axes('pos',[0 1 1 1],'visible','off','Tag','suptitle');
ht=text(.5,titleypos-1,str);set(ht,'horizontalalignment','center','fontsize',fs);
set(gcf,'nextplot',np);
axes(haold);
if nargout,
	hout=ht;
end



